import javafx.scene.transform.Shear;

import javax.swing.*;
import javax.swing.border.Border;
import java.awt.*;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.MouseEvent;
import java.awt.event.MouseListener;

public class InsomniaGUI {
    JFrame frame ;
    public InsomniaGUI(){
        frame = new JFrame();
        frame.setTitle("Insomnia");
        frame.setSize(900,600);
        frame.setLocation(200,100);
        frame.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
        frame.setVisible(true);


        VerticalFlowLayout vfLayout = new VerticalFlowLayout();
        Border border = BorderFactory.createLineBorder(Color.BLACK,3);

        JMenuBar upperMenuBar = new JMenuBar();
        JMenu application = new JMenu("Application");
        JMenu edit = new JMenu("Edit");
        JMenu view = new JMenu("View");
        JMenu window = new JMenu("Tools");
        JMenuItem minimize = new JMenuItem("Minimize");
        window.add(minimize);
        JMenu help = new JMenu("Help");
        upperMenuBar.add(application);
        upperMenuBar.add(edit);
        upperMenuBar.add(view);
        upperMenuBar.add(window);
        upperMenuBar.add(help);

        JPanel body = new JPanel();
        body.setBackground(Color.GRAY);
        JPanel auth = new JPanel();
        auth.setBackground(Color.GRAY);
        JPanel query = new JPanel();
        query.setBackground(Color.GRAY);
        JPanel mainCenterHeader = new JPanel(vfLayout);
        mainCenterHeader.setBackground(Color.GRAY);
        JScrollPane scrollPane_Header_Request = new JScrollPane(mainCenterHeader);
        scrollPane_Header_Request.setVerticalScrollBarPolicy(JScrollPane.VERTICAL_SCROLLBAR_ALWAYS);
        JPanel docs = new JPanel();
        docs.setBackground(Color.GRAY);


        //request-center
        JTabbedPane tabbedPaneCenterRequest = new JTabbedPane();
        tabbedPaneCenterRequest.setBackground(Color.GRAY);
        tabbedPaneCenterRequest.add("Body" , body);
        tabbedPaneCenterRequest.add("Auth" , auth);
        tabbedPaneCenterRequest.add("Query" , query);
        tabbedPaneCenterRequest.add("Header" , scrollPane_Header_Request);
        tabbedPaneCenterRequest.add("Docs" , docs);
        JTextField headerField = new JTextField("header");
        headerField.addMouseListener(new MouseListener() {
            @Override
            public void mouseClicked(MouseEvent e) {
                JTextField newHeaderField = new JTextField("header");
                newHeaderField.setBorder(border);
                JTextField newValueField = new JTextField("value");
                newValueField.setBorder(border);
                JCheckBox newCheckBox = new JCheckBox();
                ImageIcon newQuitIcon = new ImageIcon();
                JButton newDelete = new JButton(newQuitIcon);
                JPanel newRightOfHeader = new JPanel();
                newRightOfHeader.add(newCheckBox);
                newRightOfHeader.add(newDelete);
                JPanel new_center_header = new JPanel(new GridLayout(1, 2));
                new_center_header.add(newHeaderField);
                new_center_header.add(newValueField);
                JPanel newHeader = new JPanel(new BorderLayout());
                newHeader.add(newRightOfHeader, BorderLayout.EAST);
                newHeader.add(new_center_header, BorderLayout.CENTER);
                mainCenterHeader.add(newHeader );

            }

            @Override
            public void mousePressed(MouseEvent e) {

            }

            @Override
            public void mouseReleased(MouseEvent e) {

            }

            @Override
            public void mouseEntered(MouseEvent e) {

            }

            @Override
            public void mouseExited(MouseEvent e) {

            }
        });
        TextFieldHandler textFieldHandler = new TextFieldHandler(headerField,mainCenterHeader,border);//create a actionListener
        headerField.setFocusable(true);
        headerField.addActionListener( textFieldHandler);
        headerField.setBorder(border);
        JTextField valueField = new JTextField("value");
        valueField.setBorder(border);
        JCheckBox checkBox = new JCheckBox();
        ImageIcon quitIcon = new ImageIcon();
        JButton delete = new JButton(quitIcon);
        JPanel rightOfHeader = new JPanel();
        rightOfHeader.add(checkBox);
        rightOfHeader.add(delete);
        JPanel center_header = new JPanel(new GridLayout(1,2));
        center_header.add(headerField);
        center_header.add(valueField);
        JPanel header = new JPanel(new BorderLayout());
        header.add(rightOfHeader,BorderLayout.EAST);
        header.add(center_header,BorderLayout.CENTER);
        mainCenterHeader.add(header);




        //request_up
        String s []={"Patch","Put","Post","Delete","Get"};
        JComboBox centerMenu = new JComboBox(s);
        centerMenu.setFont(new Font("Arial",20,15 ));

        JTextField URLTextField = new JTextField("http://api.myproduct.com/v1/users");

        JButton sendButton = new JButton("send");

        JPanel centerUp = new JPanel(new BorderLayout());
        centerUp.add(centerMenu , BorderLayout.WEST);
        centerUp.add(URLTextField , BorderLayout.CENTER);
        centerUp.add(sendButton , BorderLayout.EAST);

        JPanel request = new JPanel(new BorderLayout());
        request.add(centerUp,BorderLayout.NORTH);
        request.add(tabbedPaneCenterRequest , BorderLayout.CENTER);

        //respond
        JPanel row = new JPanel();
        row.setBackground(Color.GRAY);
        JPanel mainCenterHeader_respond = new JPanel(vfLayout);
        JScrollPane scrollPane_Header_Request2 = new JScrollPane(mainCenterHeader_respond);
        scrollPane_Header_Request.setVerticalScrollBarPolicy(JScrollPane.VERTICAL_SCROLLBAR_ALWAYS);
        mainCenterHeader_respond.setBackground(Color.GRAY);
        JPanel header_MainPanel = new JPanel(new BorderLayout());
        header_MainPanel.setBackground(Color.GRAY);
        JButton copyToClipBoard = new JButton("copy to clip board");
        header_MainPanel.add(scrollPane_Header_Request2 , BorderLayout.CENTER);
        header_MainPanel.add(copyToClipBoard,BorderLayout.SOUTH);
        JPanel cookie = new JPanel();
        cookie.setBackground(Color.GRAY);
        JPanel timeline = new JPanel(new BorderLayout());
        timeline.setBackground(Color.GRAY);
        JTabbedPane tabbedPaneCenterResponse = new JTabbedPane();
        tabbedPaneCenterResponse.setBackground(Color.GRAY);
        tabbedPaneCenterResponse.add("Row" , row);
        tabbedPaneCenterResponse.add("Header" , header_MainPanel);
        tabbedPaneCenterResponse.add("Cookie", cookie);
        tabbedPaneCenterResponse.add("Timeline" , timeline);
        JPanel response = new JPanel(new BorderLayout());
        JTextField headerField2 = new JTextField("header");
        headerField2.setEditable(false);
        headerField2.addMouseListener(new MouseListener() {
            @Override
            public void mouseClicked(MouseEvent e) {
                System.out.println(")))))))))))");
               // if (!headerField2.getText().equals("") ) {
                    JTextField newHeaderField = new JTextField("header");
                    newHeaderField.setEditable(false);
                    newHeaderField.setBorder(border);
                    JTextField newValueField = new JTextField("value");
                    newValueField.setEditable(false);
                    newValueField.setBorder(border);
                    JPanel new_center_header = new JPanel(new GridLayout(1, 2));
                    new_center_header.add(newHeaderField);
                    new_center_header.add(newValueField);
                    JPanel newHeader = new JPanel(new BorderLayout());
                    newHeader.add(new_center_header, BorderLayout.CENTER);
                    mainCenterHeader_respond.add(newHeader );
             //   }
            }

            @Override
            public void mousePressed(MouseEvent e) {

            }

            @Override
            public void mouseReleased(MouseEvent e) {

            }

            @Override
            public void mouseEntered(MouseEvent e) {

            }

            @Override
            public void mouseExited(MouseEvent e) {

            }
        });
        headerField2.setBorder(border);
        JTextField valueField2 = new JTextField("value");
        valueField2.setEditable(false);
        valueField2.setBorder(border);
        JPanel center_header2 = new JPanel(new GridLayout(1,2));
        center_header2.add(headerField2);
        center_header2.add(valueField2);
        JPanel header2 = new JPanel(new BorderLayout());
        header2.add(center_header2,BorderLayout.CENTER);
        mainCenterHeader_respond.add(header2);




        JPanel up_response = new JPanel();
        JLabel label1 = new JLabel("ok");
        label1.setBorder(border);
        JLabel label2 = new JLabel("s");
        label2.setBorder(border);
        JLabel label3 = new JLabel("KB");
        label3.setBorder(border);
        up_response.add(label1);
        up_response.add(label2);
        up_response.add(label3);

        response.add(tabbedPaneCenterResponse , BorderLayout.CENTER);
        response.add(up_response,BorderLayout.NORTH);


        JPanel panelRight = new JPanel(new GridLayout(1 ,2 ));
        panelRight.add(request);
        panelRight.add(response);

        JMenu menu = new JMenu("Insomnia");
        menu.setFont(new Font("Arial",20,15 ));
        menu.setBorder(border);
        menu.setPreferredSize(new Dimension(200,60));
        JButton addRequest = new JButton("Add Request");
        JPanel up_left = new JPanel(new GridLayout(2,1));
        up_left.add(menu);
        up_left.add(addRequest);
        JPanel requestList = new JPanel(vfLayout);
        JScrollPane scrollRequests = new JScrollPane(requestList);
        addRequest.addMouseListener(new MouseListener() {
            @Override
            public void mouseClicked(MouseEvent e) {
                int i = 1;
                JLabel jLabel= new JLabel("request"+i);
                requestList.add(jLabel);
                i++;
            }

            @Override
            public void mousePressed(MouseEvent e) {

            }

            @Override
            public void mouseReleased(MouseEvent e) {

            }

            @Override
            public void mouseEntered(MouseEvent e) {

            }

            @Override
            public void mouseExited(MouseEvent e) {

            }
        });
        JPanel panelLeft = new JPanel(new BorderLayout());
        panelLeft.add(up_left , BorderLayout.NORTH);
        panelLeft.add(scrollRequests, BorderLayout.CENTER);
        panelLeft.setBackground(Color.LIGHT_GRAY);

        JPanel panel = new JPanel(new BorderLayout());
        panel.add(upperMenuBar , BorderLayout.NORTH);
        panel.add(panelLeft , BorderLayout.WEST);
        panel.add(panelRight , BorderLayout.CENTER);

        frame.getContentPane().add(panel);
    }

    private class TextFieldHandler implements ActionListener{
        JTextField headerField ;
        JPanel mainCenterHeader;
        Border border;
        private TextFieldHandler(JTextField headerField , JPanel mainCenterHeader , Border border){
            this.headerField = headerField;
            this.mainCenterHeader = mainCenterHeader;
            this.border = border;
        }
        @Override
        public void actionPerformed(ActionEvent e) {
            System.out.println("++++++++++++");
            if (!headerField.getText().equals("") ) {
                JTextField newHeaderField = new JTextField("header");
                newHeaderField.setBorder(border);
                JTextField newValueField = new JTextField("value");
                newValueField.setBorder(border);
                JCheckBox newCheckBox = new JCheckBox();
                ImageIcon newQuitIcon = new ImageIcon();
                JButton newDelete = new JButton(newQuitIcon);
                JPanel newRightOfHeader = new JPanel();
                newRightOfHeader.add(newCheckBox);
                newRightOfHeader.add(newDelete);
                JPanel new_center_header = new JPanel(new GridLayout(1, 2));
                new_center_header.add(newHeaderField);
                new_center_header.add(newValueField);
                JPanel newHeader = new JPanel(new BorderLayout());
                newHeader.add(newRightOfHeader, BorderLayout.EAST);
                newHeader.add(new_center_header, BorderLayout.CENTER);
                mainCenterHeader.add(newHeader);
            }
        }
    }
}
